#*************************************************************
# Progamm:			venus_temperatur
# Sinn des Programms: 		Berechnung der Temperatur am Venusboden
# Sinn der Einheit  :		Ausgabeeinheit 	
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		venus_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5	
# Autor: 			Armin Ulrich
# Erster Lauf: 			31.01.2022
# Letzte Änderung: 		26.08.2022
#*************************************************************



#*************************************************************
# Importieren der Klassen
# matplotlib.pyplot: für graphische Ausgabe
#*************************************************************

import os

import matplotlib.pyplot as plt
#import numpy as np

#*************************************************************
# Klassendefinition: Ausgabe
#*************************************************************



class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt") 


  def schirm_ausgabe(self,m, p, T, T_celsius):
    print("Schirmausgabe")
    for i in range(m):
      print("%5i" %i, "%6.3f" %p[i],"%6.3f" %T[i],"%6.3f" %T_celsius[i])
    return True  


  def datei_ausgabe(self,ausgabe_datei,  m, p, T, T_celsius):
      fobj_out = open(ausgabe_datei,"w")
      fobj_out.write("\n")
      fobj_out.write(str(m))
      fobj_out.write("\n")
      for i in range(m):
        fobj_out.write(str("%5i" %i))
        fobj_out.write("\t")
        fobj_out.write(str("%6.3f" %p[i]))
        fobj_out.write("\t")
        fobj_out.write(str("%6.3f" %T[i]))
        fobj_out.write("\t")
        fobj_out.write(str("%6.3f" %T_celsius[i]))
        fobj_out.write("\n")  
      fobj_out.close()


  def graphik_ausgabe(self, m,p,T,graphik_datei_ausgabe_wähler ,graphik_datei_name, graphik_datei_format, einheit):
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    for i in range(m):
      if x_min >= p[i]:
        x_min = p[i]
      if x_max <= p[i]:
        x_max = p[i]
      if y_min >= T[i]:
        y_min = T[i]
      if y_max <= T[i]:
        y_max = T[i]  

    plt.plot(p, T, 'r.')  
      # Achsen-Bereiche manuell festlegen
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title("Venus-atmosphäre" )
    plt.xlabel("Druck [bar]")
    if einheit == "K":
      plt.ylabel('Temperatur [K]')
    if einheit == "C": 
      plt.ylabel('Temperatur [°C]')
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_ausgabe_wähler ):
      if einheit == "K":      
        plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
      if einheit == "C":  
                plt.savefig(graphik_datei_name + '_celsius.' + graphik_datei_format, format=graphik_datei_format) 
    plt.show()    
  


   
  
  
