#*************************************************************
# Progamm:			venus_temperatur
# Sinn des Programms: 		Berechnung der Temperatur am Venusboden
# Sinn der Einheit  :		Einlesen der CO_2-Stoffwerte 	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		venus_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			31.01.2022
# Letzte Änderung: 		10.03.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os

import numpy as np


class Einlese:
  #Konstruktormethode
  def __init__(self):		
    print("Wärmemengenobjekt erzeugt")
    

  #Destruktormethode
  def __del__(self):	
    print("Wärmemengenobjekt entfernt")  

  def ende(self):
    self.main.destroy()    


#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def input_wärmekapazität(self, stoff_werte_datei):
    print("Einlesen der Wärmemengen") 
    self.zeilen_zähler=0
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists(stoff_werte_datei):
      fobj_in = open(stoff_werte_datei,"r") 
      for zeile in fobj_in:
        self.zeilen_zähler += 1
      fobj_in.close()  
      self.k = self.zeilen_zähler
      print("k=", self.k)   

      
      self.einlese_liste = list(range(self.zeilen_zähler)) 
      self.T_einlese =  np.zeros(self.k-3)
      self.cp =  np.zeros(self.k-3)
      self.zeilen_zähler = 0
      
      fobj_in = open(stoff_werte_datei,"r")
      for zeile in fobj_in:
        self.einlese_liste[self.zeilen_zähler] = zeile[:-1]
        #print(self.einlese_liste[self.zeilen_zähler])
        if self.zeilen_zähler == 1:
          self.R = float(self.einlese_liste[self.zeilen_zähler])
          print("R =", self.R)
        if self.zeilen_zähler >= 3:  
          dummy   = self.einlese_liste[self.zeilen_zähler].split("\t") 
          self.T_einlese[self.zeilen_zähler-3] = float(dummy[0])
          self.cp[self.zeilen_zähler-3] = float(dummy[1])
        self.zeilen_zähler +=1
      fobj_in.close()  
      self.n = self.k-3    
      for i in range(self.n) :
        print(self.T_einlese[i], self.cp[i])  
      return True
    else:
      print("Datei ist NICHT vorhanden")
      return False      




    
 

