#*************************************************************
# Progamm:			venus_temperatur
# Sinn des Programms: 		Berechnung der Temperatur am Venusboden
# Sinn der Einheit  :		Berechnung der Temperaturverteilung in der Venusatmosphäre 	
# Name dieser Datei:		rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		venus_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			31.01.2022
# Letzte Änderung: 		26.08.2022
#*************************************************************
import numpy as np

class Rechner:
  #Konstruktormethode
  def __init__(self):		
    print("Rechnerobjekt erzeugt")
    
  
  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")  
    
  def kappa_rechner(self,p_oben, p_unten, T_oben, T_unten,m,n,R,T_einlese,cp):
    print("Rechner") 
    print(R)
    print(T_einlese)
    print(cp)
    print(n)
    cv =  np.zeros((n))
    self.kappa = np.zeros(n)
    for i in range(n):
      cv[i] = cp[i] - R
      self.kappa[i] = cp[i]/cv[i]
    
    for i in range(n):
      print(i,T_einlese[i], cp[i], cv[i], self.kappa[i])

    self.p = np.zeros((m))
    self.T = np.zeros((m))
    self.T_celsius = np.zeros((m))    
    
    self.T[0] = T_oben
    self.T_celsius[0] = T_oben - 273.15
    delta_p = (p_unten - p_oben)/float(m)
    for i in range(m):
      self.p[i] = p_oben + delta_p*float(i)
      print(self.p[i])
    for i in range(m-1):
      kappa_berechnet = self.interpolation(n,self.T[i],T_einlese,self.kappa)
#      kappa_berechnet = 1.3
      self.T[i+1] = self.T[i]*(self.p[i+1]/self.p[i])**((kappa_berechnet-1.0)/kappa_berechnet)    
      self.T_celsius[i+1] = self.T[i+1]  - 273.15
      print(kappa_berechnet, self.T[i+1])    
    return True
    
    
  def interpolation(self,n,T,T_einlese,kappa):
    for j in range(n-1): 
      if ((T_einlese[j]<=T) & (T<T_einlese[j+1])):
        kappa_interpoliert = kappa[j]*(T_einlese[j+1]-T)/(T_einlese[j+1]-T_einlese[j])  +  kappa[j+1]*(T-T_einlese[j])/(T_einlese[j+1]-T_einlese[j])
    return kappa_interpoliert  
