#*************************************************************
# Progamm:			venus_temperatur
# Sinn des Programms: 		Berechnung der Temperatur am Venusboden
# Sinn der Einheit  :		Steuereinheit	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		venus_atmosphaere_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			31.01.2022
# Letzte Änderung: 		14.03.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

#*************************************************************
# Abschalten der GUI-Funktionen nach Gebrauch
#*************************************************************     
  def ändern(self):
    self.eingabe_gui.destroy()   
    print(self.eingabe_neu())
        
  def ende(self):
    self.eingabe_gui.destroy()     
    
  def ende_neu(self):
    self.eingabe_gui_neu.destroy()  

#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    self.rückgabeliste = list(range(5))
    self.rückgabeliste[0] = True                                   # Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[1] = "Steuerdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Steuerdatei  Text
    self.rückgabeliste[2] = False ##                                  # Manuelle Änderung                           True/False
    self.rückgabeliste[3] = True                                   # Manuelle Änderung korrekt                   True/False
    self.rückgabeliste[4] = "Keine Fehler in der Änderung"         # Fehlermeldung für manuelle Änderung         Text  
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"): 
      print("Steuerdatei ist vorhanden")

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************    
      import tkinter
      self.eingabe_gui = tkinter.Tk()  
      print("Eingabedaten werden eingelesen")
      self.zeilen_zähler = 0
      fobj_in = open("steuer.txt","r")       
      for line in fobj_in:
        self.zeilen_zähler+=1
      fobj_in.close()  
      
      self.anzeige_liste = list(range(self.zeilen_zähler)) 
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      
      for zeile in fobj_in:
        self.anzeige_liste[self.zeilen_zähler] = zeile[:-1]
        if self.zeilen_zähler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.stoff_werte_datei = zeile[:-1]
          print(self.stoff_werte_datei)
        if self.zeilen_zähler == 3:
          self.ausgabe_datei = zeile[:-1]  
          
        if self.zeilen_zähler == 5:
          self.graphik_datei_name = zeile[:-1]

        if self.zeilen_zähler == 7:
          self.graphik_datei_format = zeile[:-1] 
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"
                
        if self.zeilen_zähler == 9:
          try:
            self.p_oben = float(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen p_unten ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 11:
          try:
            self.p_unten = float(zeile[:-1])   
            if self.p_oben < self.p_unten:
              pass
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: p_oben muß kleiner p_unten sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablenp_unten ist keine Zahl!\nProgramm bricht ab!"
                               
        if self.zeilen_zähler == 13:
          try:
            self.T_oben = float(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen T_unten ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 15:
          try:
            self.T_unten = float(zeile[:-1])   
            if self.T_oben < self.T_unten:
              pass
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: T_oben muß kleiner T_unten sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen T_unten ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 17:
          try:
            self.m = int(zeile[:-1])
            if self.m > 4:
              pass
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen m ist zu klein!\nm sollte > 4 sein.\nProgramm bricht ab!"
              print(self.rückgabeliste[1])   
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen m ist keine Integer-Zahl!\nProgramm bricht ab!"
                   

        if self.zeilen_zähler == 19:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1]) 
        if self.zeilen_zähler == 21:
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 23:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 25:
          self.graphik_datei_ausgabe_wähler = self.bool_function(zeile[:-1])              
        self.zeilen_zähler += 1    
      fobj_in.close()

#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
#*************************************************************   
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui, text = self.anzeige_liste[i])
        
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      weiter_button = tkinter.Button(self.eingabe_gui, text = "weiter", command = self.ende)
      weiter_button.grid(row=int(i/2+1), column=0, padx='1', pady='1', sticky='ew')
      ändern_button = tkinter.Button(self.eingabe_gui, text = "Eingabe ändern", command = self.ändern)
      ändern_button.grid(row=int(i/2+1), column=1, padx='1', pady='1', sticky='ew')
      #Endlosschleife
      self.eingabe_gui.mainloop()
      print("Einlesen der Steuerdaten o.k.")

    else:
      self.rückgabeliste[0] = False 
      self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden!"  
      
    self.rückgabewert = self.rückgabeliste[0]  
    return self.rückgabewert

  def übernahme(self): 
    dummy = self.änderungs_feld_stoff_werte_datei.get()
#*************************************************************
# Test ob in das Feld etwas eingeschrieben wurde
# wenn nicht, dann dummy != "" False
#*************************************************************    
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.stoff_werte_datei = dummy
      print("Stoffwertedatei geändert:", self.stoff_werte_datei) 
    else:
      print("Keine Änderung der Variablen")

    dummy = self.änderungs_feld_ausgabe_datei.get()
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.ausgabe_datei = dummy
      print("Ausgabedatei geändert:", self.ausgabe_datei) 
    else:
      print("Keine Änderung der Variablen")


            
    dummy = self.änderungs_feld_graphik_datei_name.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_datei_name = dummy
      print("graphik_datei_name geändert:", self.graphik_datei_name) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_datei_format.get()
    if dummy != "": 
      self.rückgabeliste[2] = True  
      if dummy in self.graphik_formate_zulässig:
        self.graphik_datei_format = dummy
      else:
        self.rückgabeliste[3] = False 
        self.rückgabeliste[4] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      print("graphik_datei_format geändert:",  self.graphik_datei_format) 
    else:
      print("Keine Änderung der Variablen") 


#*************************************************************
# Test ob in das Feld eingeschriebene(s) Zeichen eine Zahl ist/sind
# d.h. zu float konvertierbar ist
#*************************************************************

    dummy = self.änderungs_feld_p_oben.get()
    if dummy != "":  
      try:
        if float(dummy) < self.p_unten:
          self.p_oben = float(dummy)
          self.rückgabeliste[2] = True 
          print("x_ost geändert:",  self.p_oben) 
        else:
          self.rückgabeliste[3] = False  
          self.rückgabeliste[4] = "Fehler in Steuerdatei: p_unten muß kleiner x_ost sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen p_oben ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_p_unten.get()
    if dummy != "":  
      try:
        if self.p_oben < float(dummy):
          self.p_unten = float(dummy)
          self.rückgabeliste[2] = True 
          print("p_unten geändert:",  self.p_unten) 
        else:
          self.rückgabeliste[3] = False  
          self.rückgabeliste[4] = "Fehler in Steuerdatei: p_oben muß kleiner p_unten sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen p_unten ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_T_oben.get()
    if dummy != "":  
      try:
        if float(dummy) < self.T_unten:
          self.T_oben = float(dummy)
          self.rückgabeliste[2] = True 
          print("x_ost geändert:",  self.T_oben) 
        else:
          self.rückgabeliste[3] = False  
          self.rückgabeliste[4] = "Fehler in Steuerdatei: T_oben muß kleiner T_unten sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen T_oben ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_T_unten.get()
    if dummy != "":  
      try:
        if self.T_oben < float(dummy):
          self.T_unten = float(dummy)
          self.rückgabeliste[2] = True 
          print("x_ost geändert:",  self.T_unten) 
        else:
          self.rückgabeliste[3] = False  
          self.rückgabeliste[4] = "Fehler in Steuerdatei: T_oben muß kleiner T_unten sein!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen T_unten ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")        
      
    dummy = self.änderungs_feld_m.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      try:
        test_integer = int(dummy) 
        if test_integer > 4:
          self.m = int(dummy)
          print("m geändert:",  self.m)
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen m ist zu klein!\nm sollte > 4 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen m ist keine Integer-Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")     
                 
      
    dummy = self.änderungs_feld_schirm_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.schirm_ausgabe_wähler = self.bool_function(dummy)
      print("schirm_ausgabe_wähler geändert:",  self.schirm_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_datei_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.datei_ausgabe_wähler =self.bool_function(dummy)
      print("datei_ausgabe_wähler geändert:", self.datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")                          
                                    
    dummy = self.änderungs_feld_graphik_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_ausgabe_wähler geändert:", self.graphik_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 
      
    dummy = self.änderungs_feld_graphik_datei_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_datei_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_datei_ausgabe_wähler geändert:", self.graphik_datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 


#*************************************************************
# Abspeichern der veränderten Eingabedaten in eine neue Datei
#*************************************************************
    if(self.rückgabeliste[2] == True ):
      fobj_out = open("steuer_neu.txt","w")   
      fobj_out.write("Name der Stoffwertedatei:\n")
      fobj_out.write(self.stoff_werte_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.ausgabe_datei)
      fobj_out.write("\n")      
      fobj_out.write("Name der Graphikdatei:\n")
      fobj_out.write(self.graphik_datei_name) 
      fobj_out.write("\n")
      fobj_out.write("Format der Graphikdatei:\n")
      fobj_out.write(self.graphik_datei_format)
      fobj_out.write("\n")
      fobj_out.write("p_oben:\n")
      fobj_out.write(str("%8.6f" %self.p_oben))
      fobj_out.write("\n")
      fobj_out.write("p_unten:\n")
      fobj_out.write(str("%8.6f" %self.p_unten))
      fobj_out.write("\n")
      fobj_out.write("T_oben:\n")
      fobj_out.write(str("%8.6f" %self.T_oben))
      fobj_out.write("\n")
      fobj_out.write("T_unten:\n")
      fobj_out.write(str("%8.6f" %self.T_unten))
      fobj_out.write("\n")      
      fobj_out.write("Anzahl der Gitterpunkte:\n")
      fobj_out.write(str("%8i" %self.m))
      fobj_out.write("\n")
      fobj_out.write("Bildschirmausgabe?:\n")
      fobj_out.write(str(self.schirm_ausgabe_wähler)) 
      fobj_out.write("\n")     
      fobj_out.write("Dateiausgabe?:\n")
      fobj_out.write(str(self.datei_ausgabe_wähler)) 
      fobj_out.write("\n")
      fobj_out.write("Graphikausgabe?:\n")
      fobj_out.write(str(self.graphik_ausgabe_wähler)) 
      fobj_out.write("Graphikdateiausgabe?:\n")
      fobj_out.write(str(self.graphik_datei_ausgabe_wähler)) 
      fobj_out.write("\n")                      
      fobj_out.close   
    else:
      pass
                                
#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
# sowie der Möglichkeit, andere Eingabedaten einzugeben
#*************************************************************    
  def eingabe_neu(self):
    try:
      import tkinter
      self.eingabe_gui_neu = tkinter.Tk() 
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui_neu, text = self.anzeige_liste[i])
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
      
      self.änderungs_feld_stoff_werte_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_ausgabe_datei = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_graphik_datei_name = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_format = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_p_oben= tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_p_unten = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_T_oben= tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_T_unten = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_m = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_schirm_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_stoff_werte_datei.grid(row=0, column=2, padx='1', pady='1', sticky='ew')   
      self.änderungs_feld_ausgabe_datei.grid(row=1, column=2, padx='1', pady='1', sticky='ew')         
      self.änderungs_feld_graphik_datei_name.grid(row=2, column=2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_datei_format.grid(row=3, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_p_oben.grid(row=4, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_p_unten.grid(row=5, column=2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_T_oben.grid(row=6, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_T_unten.grid(row=7, column=2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_m .grid(row=8, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_schirm_ausgabe_wähler.grid(row=9, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler.grid(row=10, column=2, padx='1', pady='1', sticky='ew')   
      self.änderungs_feld_graphik_ausgabe_wähler.grid(row=11, column=2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_datei_ausgabe_wähler.grid(row=12, column=2, padx='1', pady='1', sticky='ew')
 
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten
# Button zur Übernahme der geänderten Eingabedaten
# zum Start der Berechnungen
#*************************************************************      
      weiter_button = tkinter.Button(self.eingabe_gui_neu, text = "weiter", command = self.ende_neu)
      weiter_button.grid(row=13, column=0, padx='1', pady='1', sticky='ew')
      übernahme_button = tkinter.Button(self.eingabe_gui_neu, text = "übernehmen", command = self.übernahme)
      übernahme_button.grid(row=13, column=2, padx='1', pady='1', sticky='ew')
      
      #Endlosschleife
      self.eingabe_gui_neu.mainloop()
           
      print("Einlesen o.k.")
      self.rückgabewert = True
  
    except:
      print("Fehler beim Dateieinlesen")
      self.rückgabewert = False
      self.rückgabeliste[0] = self.rückgabewert 
    return self.rückgabeliste   

     
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return True

