#*************************************************************
# Progamm:			venus_temperatur
# Sinn des Programms: 		Berechnung der Temperatur am Venusboden
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		venus_temperatur_haupt.py
# Versionsnummer:		1
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, einlese.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			31.01.2022
# Letzte Änderung: 		26.08.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime

#*************************************************************
# Importieren der Klassen
#*************************************************************

from steuer import Steuer
from einlese import Einlese
from rechner import Rechner
from ausgabe import Ausgabe

steuer = Steuer()
einlese = Einlese()
rechner = Rechner()
ausgabe = Ausgabe()

print("venus_temperatur:")

#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)

#*************************************************************
# Öffnen der log-Datei
#*************************************************************
fobj_log = open("venus_atmosphaere.log","w")

#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")

#*************************************************************
# Einlesen der Steuerdaten und Erfolgskontrolle
#*************************************************************
if(steuer.steuer_input()):
  fobj_log.write( "Steuerdatei existiert!\n")
  #if(steuer.rückgabeliste[2] == True): #Hier noch mal schauen !!!!!!!!!!!!!!!!!!!!!!!!!!
  if(steuer.rückgabeliste[3] == True):
    print(steuer.rückgabeliste[4])
    fobj_log.write(steuer.rückgabeliste[4] + "\n")
    if einlese.input_wärmekapazität(steuer.stoff_werte_datei):
      fobj_log.write( "Wärmekapazitäten wurden eingelesen\n")
      if rechner.kappa_rechner(steuer.p_oben, steuer.p_unten,steuer.T_oben, steuer.T_unten,steuer.m, einlese.n, einlese.R, einlese.T_einlese, einlese.cp):
        if steuer.schirm_ausgabe_wähler:
          ausgabe.schirm_ausgabe(steuer.m, rechner.p, rechner.T, rechner.T_celsius)
        if steuer.datei_ausgabe_wähler:
          ausgabe.datei_ausgabe(steuer.ausgabe_datei, steuer.m, rechner.p, rechner.T, rechner.T_celsius )  
        if steuer.graphik_ausgabe_wähler:
          ausgabe.graphik_ausgabe(steuer.m, rechner.p, rechner.T, steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_datei_name, steuer.graphik_datei_format, "K")     
        if steuer.graphik_ausgabe_wähler:
          ausgabe.graphik_ausgabe(steuer.m, rechner.p, rechner.T_celsius, steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_datei_name ,steuer.graphik_datei_format, "C")                  
      else:
        pass  
    else:
      fobj_log.write( "Fehler beim Einlesen der Wärmekapazitäten\n")   
  else:
    print(steuer.rückgabeliste[4])  
    fobj_log.write(steuer.rückgabeliste[4] + "\n")
    
 
else:
  print(steuer.rückgabeliste[1])
  fobj_log.write( steuer.rückgabeliste[1]+"\n")
  
#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))

#*************************************************************
# Schließen der Logdatei
#*************************************************************
fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************

#*************************************************************
#Programmende
#*************************************************************


